#include <iomanip>
#include <fstream>
#include <LiDIA/bigint.h>

#define MAXTAM 200

using namespace LiDIA;
using namespace std;

class bloque
{
protected:
  unsigned char w[MAXTAM];
  static int tam1;
  static int tam2;
  static bool cif;
  static bool ultimoBloque;
public:
  bigint num;
  bloque(int t1, int t2){tam1=t1; tam2=t2;}
  void cifrando(bool c){cif = c;}
  bool cifrando(){return cif;}
  bool descifrando(){return !cif;}
  void b2n();
  void n2b();
  friend ostream& operator<< (ostream& fich, bloque & b);
  friend istream& operator>> (istream& fich, bloque & b);
};

int bloque::tam1;
int bloque::tam2;
bool bloque::ultimoBloque;
bool bloque::cif;

ostream& operator<< (ostream& fich, bloque & b)
  {
  int j,tam;
  if(b.cifrando())
    tam=b.tam2;
  else 
    tam=b.tam1;
  if(b.descifrando() && b.ultimoBloque) 
    tam = b.w[tam-1];
  for(j=0;j<tam;j++)
    fich << b.w[j];
  }

istream& operator>> (istream& fich, bloque& b)
  {
  int j,tam;
  if(b.cifrando())
    {
    bool fin[MAXTAM];
    tam=b.tam1;
    for(j=0;j<tam;j++)
      {
      fich >> b.w[j];
      fin[j] = fich.eof();
      }
    if(fich.eof())
      {
      int temp;
      for(temp=0;!fin[temp];temp++);
      b.w[tam-1]=temp;
      }  
    }
  else
    {
    tam=b.tam2;
    unsigned char c;
    for(j=0;j<tam;j++)
      fich >> b.w[j];
    fich >> c;
    b.ultimoBloque = fich.eof();
    fich.putback(c);
    }
  }

void bloque::b2n()
{
  int j,tam;
  bigint m;
  if(cifrando())
    tam=tam1;
  else 
    tam=tam2;
  num=0;
  m = 1;
  for(j=0;j<tam;j++,m*=256)
    num = num + w[j]*m;
}  

void bloque::n2b()
{
  int j,tam;
  if(cifrando())
    tam=tam2;
  else 
    tam=tam1;
  for(j=0;j<tam;j++)
    {
    w[j] = remainder(num,256);
    num /= 256;
    }
}  
